﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;


namespace FeatureToggles
{
    public class SQLFeatureToggleStore 
    {
        #region private fields
        
        /// <summary>
        /// _connectionString
        /// </summary>
        private String _connectionString;

        #endregion private fields

        #region public methods

        /// <summary>
        ///  SQLFeatureFlagsStoresStore Constructor
        /// </summary>
        /// <param name="connectionString"></param>
        public SQLFeatureToggleStore(String connectionString)
        {
            _connectionString = connectionString;
        } //  SQLFeaturesStore Constructor

        /// <summary>
        ///  LoadFeatureFlagsStores
        /// </summary>
        /// <returns></returns>
        public Dictionary<String, Boolean> LoadFeaturesFromDatabase()
        {
            Dictionary<String, Boolean> featureNamesDict = new Dictionary<String, Boolean>();
            SqlConnection connection = new SqlConnection(_connectionString);
            try
            {
                connection.Open();
                SqlCommand cmd = connection.CreateCommand();
                cmd.CommandText = Properties.Settings.Default.SPLoadFeatures;
                cmd.CommandType = CommandType.StoredProcedure;
                SqlDataReader FeatureNameReader = cmd.ExecuteReader();
                while (FeatureNameReader.Read())
                {
                    featureNamesDict.Add(FeatureNameReader[0].ToString(), Boolean.Parse(FeatureNameReader[1].ToString()));
                } // End while
                FeatureNameReader.Close();
            }
            catch (Exception ex)
            {
                throw;
            }
            return featureNamesDict;
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="pFeatureTogglesDict"></param>
      public void SaveFeaturesToDatabase(Dictionary<String, Boolean> pFeatureTogglesDict)
      {
          foreach (String featureKey in pFeatureTogglesDict.Keys)
          {
              InsertOrUpdateFeatures(featureKey, pFeatureTogglesDict[featureKey]);
          } // foreach
      }   //  SaveFeatureState


        #endregion public methods

        #region private methods

        /// <summary>
        /// InsertOrUpdateFeatureFlagsStore
        /// </summary>
        /// <param name="FeatureFlagsStoreFlagKey"></param>
        /// <param name="FeatureFlagsStoreFlagValue"></param>
      private void InsertOrUpdateFeatures(String featureToggleName, Boolean isEnabled)
      {
          SqlConnection connection = new SqlConnection(_connectionString);
          try
          {
              connection.Open();
              SqlCommand cmd = connection.CreateCommand();
              cmd.CommandType = CommandType.StoredProcedure;
              cmd.CommandText = Properties.Settings.Default.SPInsertOrUpdate;
              cmd.Parameters.AddWithValue(Properties.Settings.Default.FeatureName, featureToggleName);
              cmd.Parameters.AddWithValue(Properties.Settings.Default.IsEnabled, isEnabled);
              
              cmd.ExecuteNonQuery();
          }   //end Try
          catch (Exception ex)
          {
              throw;
          }  // End Catch
      }   //  InsertOrUpdateFeatureFlagsStore  

        #endregion private methods

    } // class SQLFeaturesStore

}   //  namespace FeatureFlags
