﻿using FeatureToggles;       // FeatureToggles Class Library
using System;
using System.Windows.Forms;

namespace AdvancedCalculator
{
    class Program     
    {    
        [STAThread]
        static void Main()
        {
            #region Setup FeatureToggles Store
            
            String connectString = Properties.CommonSettings.Default.ConnectionString;
            SQLFeatureToggleStore sQLFeatureToggleStore = new SQLFeatureToggleStore(connectString);
            FeatureToggles.FeatureToggles.Initialize(sQLFeatureToggleStore);
            
            #endregion Setup FeatureToggles Store

            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new AdvancedCalculatorForm());

            #region Save Features Store

            FeatureToggles.FeatureToggles.SaveFeatureToggleState();

            #endregion Save Features Store

        }   // end Main
        private Program()
        {
            
        }
    }
} // end Main

